SystemOrganization addCategory: #'AL-Storage'!

Object subclass: #ALEntityReference
	instanceVariableNames: 'repository id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Storage'!

!ALEntityReference class methodsFor: 'as yet unclassified' stamp: 'cwp 3/27/2012 11:18'!
repository: aRepository id: anInteger
	^ self basicNew initializeWithRepository: aRepository id: anInteger! !

!ALEntityReference methodsFor: 'as yet unclassified' stamp: 'cwp 3/27/2012 11:23'!
= other
	^ self species = other species 
		and: [id = other id
			and: [other hasRepository: repository]]! !

!ALEntityReference methodsFor: 'as yet unclassified' stamp: 'cwp 3/27/2012 11:23'!
hasRepository: aRepository
	^ repository == aRepository! !

!ALEntityReference methodsFor: 'as yet unclassified' stamp: 'cwp 3/27/2012 11:25'!
hash
	^ id bitXor: repository identityHash! !

!ALEntityReference methodsFor: 'as yet unclassified' stamp: 'cwp 3/27/2012 11:23'!
id
	^ id! !

!ALEntityReference methodsFor: 'as yet unclassified' stamp: 'cwp 3/27/2012 11:19'!
initializeWithRepository: aRepository id: anInteger
	self initialize.
	repository := aRepository.
	id := anInteger! !

!ALEntityReference methodsFor: 'as yet unclassified' stamp: 'cwp 3/27/2012 11:20'!
value
	^ repository get: self! !

Object subclass: #ALRepository
	instanceVariableNames: 'cache storage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Storage'!

!ALRepository methodsFor: 'as yet unclassified' stamp: 'cwp 3/27/2012 13:08'!
flush
	cache := Dictionary new! !

!ALRepository methodsFor: 'as yet unclassified' stamp: 'cwp 3/27/2012 11:43'!
get: aReference
	^ cache at: aReference id ifAbsentPut:
		[| entity |
		entity := storage at: aReference id.
		ALEntityReadNotification signal.
		entity]! !

!ALRepository methodsFor: 'as yet unclassified' stamp: 'cwp 3/27/2012 13:09'!
initialize
	storage := Dictionary new.
	self flush! !

!ALRepository methodsFor: 'as yet unclassified' stamp: 'cwp 3/27/2012 13:13'!
put: anObject
	| ref |
	ALEntityWriteNotification signal.
	ref := ALEntityReference repository: self id: storage size.
	cache at: ref id put: anObject.
	storage at: ref id put: anObject.
	^ ref! !

Notification subclass: #ALStorageNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Storage'!

ALStorageNotification subclass: #ALEntityReadNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Storage'!

ALStorageNotification subclass: #ALEntityWriteNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Storage'!
